#!/bin/bash -x
DOM=g1
LOG_PATH=/var/log/libvirtd.log
IO_TIMEOUT=40
enable_log ()
{
    CONF_FILE=/etc/libvirt/libvirtd.conf
    augtool <<-EOF
        set  /files/$CONF_FILE/log_level 1
        set  /files/$CONF_FILE/log_filters "3:remote 4:event"
        set  /files/$CONF_FILE/log_outputs "1:file:$LOG_PATH"
        save
EOF
    echo '' > $LOG_PATH
}	# ----------  end of function enable_logging  ----------

enable_sanlock ()
{
    setsebool virt_use_sanlock 1
    CONF_FILE=/etc/libvirt/qemu.conf
    augtool <<-EOF
        set  /files/$CONF_FILE/lock_manager "sanlock"
        save
EOF
    CONF_FILE=/etc/libvirt/qemu-sanlock.conf
    augtool <<-EOF
        set  /files/$CONF_FILE/user  "sanlock"
        set  /files/$CONF_FILE/group  "sanlock"
        set  /files/$CONF_FILE/host_id  1 
        set  /files/$CONF_FILE/auto_disk_leases  1 
        set  /files/$CONF_FILE/disk_lease_dir  "/var/lib/libvirt/sanlock"
        set  /files/$CONF_FILE/io_timeout  $IO_TIMEOUT
        save
EOF
    systemctl restart wdmd
    systemctl restart sanlock
}	# ----------  end of function enable_sanlock  ----------

clean ()
{
    rm /var/lib/libvirt/sanlock/* -f
    virsh list|grep -q $DOM
    if [ $? -eq 0 ];then
        virsh destroy $DOM
    fi
    systemctl restart libvirtd
}	# ----------  end of function clean  ----------
enable_sanlock
enable_log
systemctl restart libvirtd

virsh start $DOM
sleep 40
/usr/bin/time -f %e ./io_timeout
#/usr/bin/time -f %e bash<<-EOF
#    shred /var/lib/libvirt/sanlock/*
#	while true; do
#	    virsh list|grep -q $DOM>/dev/null
#	    if [ $? -ne 0 ]; then
#	        break
#	    fi
#	done
#EOF

sleep 1

cp $LOG_PATH .
clean
